#ifndef LIBBOUSHI_H
#define LIBBOUSHI_H

#include <stdbool.h>
#include <sys/types.h>

typedef struct boushi boushi_t;
typedef struct boushi_cursor boushi_cursor_t;

extern size_t boushi_size(void);
extern bool boushi_init(struct boushi *, const char *dbdir);
extern void boushi_exit(struct boushi *);
extern int boushi_errno(struct boushi *);
extern const char *boushi_error(struct boushi *);

extern bool boushi_get(boushi_t *, const char *name, void **buf, size_t *len);
extern bool boushi_put(boushi_t *, const char *name, const void *buf, size_t len);
extern bool boushi_del(boushi_t *, const char *name, bool *found);
extern bool boushi_has(boushi_t *, const char *name, bool *found);

extern size_t boushi_cursor_size(void);
extern bool boushi_cursor_init(boushi_t *, boushi_cursor_t *, const char *, bool);
extern bool boushi_cursor_next(boushi_cursor_t *, char **name);
extern bool boushi_cursor_exit(boushi_cursor_t *);

#endif
